Spring2D[] corde = new Spring2D[20];

float g = 1.0;
float mass = 2.0;
float L;
float stiffness = 0.5;
float damping = 0.7;
int c;

void setup() 
{
  size(800, 800);
  smooth();
  fill(0);
  // Inputs: x, y, mass, gravity
  for (int i=0;i<corde.length;i++){
    corde[i] = new Spring2D(i, width/2+random(-5,5), height/2+random(-5,5) , mass);
  }
  L = 100.0/corde.length;
}

void draw() 
{
  background(204);
  for (int i=0;i<corde.length;i++) corde[i].update();
  for (int i=0;i<corde.length;i++) corde[i].display();
}

class Spring2D {
  int ident;
  float vx, vy; // The x- and y-axis velocities
  float x, y; // The x- and y-coordinates
  float gravity;
  float mass;
  float radius = 5;
  
  Spring2D(int i, float xpos, float ypos, float m) {
    ident = i;
    x = xpos;
    y = ypos;
    mass = m;
    vx = 0;
    vy = 0;
  }
  
  void update() {
  float forceXleft, forceXright, ax,forceYleft, forceYright, forceY, ay;
  
    if (ident > 0)  forceXleft = maforce(x, corde[ident-1].x); //(corde[ident-1].x - x) * stiffness;
    else forceXleft = 0; // a voir
    
    if (ident < corde.length -1)  forceXright = maforce(x, corde[ident+1].x); //(corde[ident+1].x - x) * stiffness;
    else forceXright = 0;
    
    ax = (forceXleft+forceXright) / mass;
    vx = damping * (vx + ax);
    
    if ((ident > 0)&&(ident<corde.length-1)) x += vx;
    else if (ident==0) x = width/4;
    else x = mouseX;
    
    if (ident > 0)  forceYleft = maforce(y, corde[ident-1].y); //(corde[ident-1].y - y) * stiffness;
    else forceYleft = 0; // a voir
    
    if (ident < corde.length -1)  forceYright = maforce(y, corde[ident+1].y); //(corde[ident+1].y - y) * stiffness;
    else forceYright = 0; // a voir
    
    forceY = forceYleft + forceYright;
    ay = g + forceY / mass;
    vy = damping * (vy + ay);
 
    if ((ident > 0)&&(ident<corde.length -1)) y += vy;
    else if (ident==0) y = height/4;
    else y = mouseY;

  }
  
  void display() {
    noStroke();
    ellipse(x, y, radius*2, radius*2);
    stroke(255);
    if (ident>0) line(x, y, corde[ident-1].x, corde[ident-1].y);
    //println(ident+" "+x+" "+y);
  }
}

float maforce(float x1, float x0) {
  return stiffness*(x0-x1);
}

float maforceV0(float x1, float x0) {
  return stiffness*(x0-x1)*(abs(x0-x1)-L)/abs(x0-x1);
}